Skip to main content

Watching CPL Codechef January 2021 solution || Watching CPL codechef problem editorial 2021

 Watching CPL Codechef January 2021 solution || Watching CPL codechef problem editorial 2021-

Problem statement-

Get excited, folks, because it is time for the final match of Codechef Premier League (CPL)!

Mike and Tracy also want to watch the grand finale, but unfortunately, they could not get tickets to the match. However, Mike is not someone who gives up so easily — he has a plan to watch the match.

The field where the match is played is surrounded by a wall with height K. Outside, there are N boxes (numbered 1 through N). For each valid i, the i-th box has a height Hi.

Mike wants to take some boxes and stack them on top of each other to build two towers. The height of each tower is the sum of heights of all the boxes that form it. Of course, no box may be in both towers. The height of each tower should be at least K. Then Mike can climb on top of one tower and Tracy on top of the other, and they can watch the match uninterrupted!

While Mike is busy stacking the boxes, Tracy would like to know the smallest number of boxes required to build two towers such that each of them has height at least K, or at least that it is impossible to build such towers. Can you help Tracy?

Input

  • The first line of the input contains a single integer T denoting the number of test cases. The description of T test cases follows.
  • The first line of each test case contains two space-separated integers N and K.
  • The second line contains N space-separated integers H1,H2,,HN.

Output

For each test case, print a single line containing one integer — the smallest number of boxes required to build two towers, or 1 if it is impossible.

Constraints

  • 1T5
  • 1N,K4,000
  • 1Hi105 for each valid i

Subtasks

Subtask #1 (30 points):

  • 1N,K100
  • 1Hi100 for each valid i

Subtask #2 (70 points): original constraints

Example Input

2
8 38
7 8 19 7 8 7 10 20
4 5
2 10 4 9

Example Output

7
2

Explanation

Example case 1: The first tower can be built with boxes 8+10+20=38 and the second tower with boxes 7+7+8+19=41. In this case, the box with height 7 is left unused.

Example case 2: We only need the box with height 10 for one tower and the box with height 9 for the other tower.

Watching CPL Codechef January 2021 solution || Watching CPL codechef problem editorial 2021


Solution -

Hint- other test cases.
8 15
10 7 7 5 1 1 1 1
output - 5

This problem is based on dynamic programming you need to learn the dynamic programming concept first.
where DP[i][k] represents minimum boxes required to make at least k hight till ith index.
we will use the suffix array here to find whether it is possible to make another box of height k. 
finally, we will print the optimal answer.
this question is similar to the 0/1 knapsack problem .
Refer this video  for better understanding -





Join telegram channel for code and editorial.-https://t.me/competitiveProgrammingDiscussion

Comments

Popular posts from this blog

codeforces rating system | Codeforces rating Newbie to Legendary Grandmaster

 Codeforces rating system | Codeforces rating Newbie to Legendary Grandmaster- Codeforces is one of the most popular platforms for competitive programmers and  codeforces rating matters a lot  .  Competitive Programming  teaches you to find the easiest solution in the quickest possible way. CP enhances your problem-solving and debugging skills giving you real-time fun. It's brain-sport. As you start solving harder and harder problems in live-contests your analytical and rational thinking intensifies. To have a good codeforces profile makes a good impression on the interviewer. If you have a good  codeforces profile so it is very easy to get a referral for product base company like amazon, google , facebook etc.So in this blog I have explained everything about codeforces rating system. What are different titles on codeforces- based on rating codeforces divide rating into 10 part. Newbie Pupil Specialist Expert Candidate Codemaster Master International Master Grandmaster Internat

Apple Division CSES Problem Set Solution | CSES Problem Set Solution Apple division with code

 Apple Division CSES Problem Set Solution | CSES Problem Set Solution Apple division with code - Apple Division CSES Problem Solution Easy Explanation. Apple division is problem is taken form cses introductory problem set.Let's Read Problem statement first. Problem Statement- Time limit:  1.00 s   Memory limit:  512 MB There are  n n  apples with known weights. Your task is to divide the apples into two groups so that the difference between the weights of the groups is minimal. Input The first input line has an integer  n n : the number of apples. The next line has  n n  integers  p 1 , p 2 , … , p n p 1 , p 2 , … , p n : the weight of each apple. Output Print one integer: the minimum difference between the weights of the groups. Constraints 1 ≤ n ≤ 20 1 ≤ n ≤ 20 1 ≤ p i ≤ 10 9 1 ≤ p i ≤ 10 9 Example Input: 5 3 2 7 4 1 Output: 1 Explanation: Group 1 has weights 2, 3 and 4 (total weight 9), and group 2 has weights 1 and 7 (total weight 8). Join Telegram channel for code discussi

Playlist CSES Problems set solution | searching ans sorting with code and explanation

 Playlist CSES Problems set solution- Playlist problem statement- Time limit:  1.00 s   Memory limit:  512 MB You are given a playlist of a radio station since its establishment. The playlist has a total of  n n  songs. What is the longest sequence of successive songs where each song is unique? Input The first input line contains an integer  n n : the number of songs. The next line has  n n  integers  k 1 , k 2 , … , k n k 1 , k 2 , … , k n : the id number of each song. Output Print the length of the longest sequence of unique songs. Constraints 1 ≤ n ≤ 2 ⋅ 10 5 1 ≤ n ≤ 2 ⋅ 10 5 1 ≤ k i ≤ 10 9 1 ≤ k i ≤ 10 9 Example Input: 8 1 2 1 3 2 7 4 2 Output:5 Playlist CSE S Problems set solution- Step -1 store value in hashmap so that we can check that song played before or not. step -2 make two-pointer i and j if v[i] has occurred earlier remove all element till v[i] and update ans.new length will be (i-j). Step 3- if v[i]  not occurred simply update ans by one.